#!/bin/sh

# etersoft-build-utils functions
ET=/usr/share/eterbuild/eterbuild
[ -s "ET" ] || exit 1
. $ET

load_mod rpm


get_pkgname_from_filename()
{
	local FN=$(basename $1)
	#local SR=$(echo ${FN/[\\*]*/})
	local SR=$(echo $FN | sed -e "s|[\[\*].*||g")
	if [ "$SR" != "$FN" ] ; then
		echo $SR
		return
	fi

	# for RPM file
	#if echo $FN | grep -q "rpm$" && [ -e "$FN" ] ; then
	#	querypackage $FN NAME
	#	return
	#fi

	# for DEB
	if rhas "$FN" "deb$" ; then
		echo ${FN/_[0-9]*/}
		return
	fi

	# libpq5.2-9.0eter-9.0.4-alt14.i586.rpm
	local SR=$(echo $FN | sed -e "s|\(.*\)-[0-9][0-9a-zA-Z\.]*-[a-z]*[0-9][0-9\.a-zA-Z]*\.[a-z0-9_]*.*$|\1|g")
	if [ "$SR" != "$FN" ] ; then
		echo $SR
		return
	fi

	# libgnustep-opal-r37181-alt3.svn20131001
	local SR=$(echo $FN | sed -e "s|\(.*\)-[a-zA-Z][0-9][0-9][0-9a-zA-Z\.]*-[a-z]*[0-9][0-9\.a-zA-Z]*\.[a-z0-9_]*.*$|\1|g")
	if [ "$SR" != "$FN" ] ; then
		echo $SR
		return
	fi

	echo ${FN/[-_][0-9]*/}
}

print_only_names()
{
	for i in $* ; do
		get_pkgname_from_filename $i
	done
}

DIRNAME="$(dirname $0)" ; [ "$DIRNAME" = "." ] && DIRNAME="$(pwd)"
PKGLIST="$@"

# TODO: epm --short wd
#WDLIST="$(loginhsh -t -i -r "epm wd $PKGLIST" $PKGLIST | grep "^  [^ ]" | sed -e "s|[0-9]*:||" | grep -E -v "(i586-|-debuginfo)")"

APTBOXDIR=$(loginhsh -t -i -q -d)-wd
mkdir -p $APTBOXDIR
mkaptbox -f $APTBOXDIR || fatal
WDLIST=$($APTBOXDIR/aptbox/apt-cache whatdepends $PKGLIST) || fatal

WDLIST="$(echo "$WDLIST" | grep "^  [^ ]" | sed -e "s|[0-9]*:||" | grep -E -v "(i586-|-debuginfo)")"

SKIPLIST="
LibreOffice-still-common
LibreOffice-still-integrated
libpng15-devel
libwine
pve-qemu-system
"

WDLIST=$(regexp_exclude_list "$SKIPLIST" "$WDLIST" )

echo $WDLIST

[ -n "$WDLIST" ] || fatal "Empty package list"

cd $DIRNAME || fatal
loginhsh -t -i -r "true" $(print_only_names $WDLIST)

HT=$(loginhsh -t -i -q -d)/chroot/.in
test -d "$HT" && test -w "$HT" || fatal
cp ./check_pkgs_bins.sh ./checkdupls.sh $HT
loginhsh -t -r "sh /.in/check_pkgs_bins.sh $(print_only_names $WDLIST)"
